SoVRMLTextureTransform Class Reference
VRML97 Classes

The SoVRMLTextureTransform class defines a transformation applied to texture coordinates. More...

`#include <Inventor/VRMLnodes/SoVRMLTextureTransform.h>`

Inheritance diagram for SoVRMLTextureTransform:

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoVRMLTextureTransform (void)
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | pick (SoPickAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFVec2f | translation
SoSFFloat | rotation
SoSFVec2f | scale
SoSFVec2f | center

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoVRMLTextureTransform ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoVRMLTextureTransform class defines a transformation applied to texture coordinates.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

    TextureTransform {
      exposedField SFVec2f center      0 0     # (-inf, inf)
      exposedField SFFloat rotation    0       # (-inf, inf)
      exposedField SFVec2f scale       1 1     # (-inf, inf)
      exposedField SFVec2f translation 0 0     # (-inf, inf)
    }

The TextureTransform node defines a 2D transformation that is applied to texture coordinates (see SoVRMLTextureCoordinate). This node affects the way textures coordinates are applied to the geometric surface. The transformation consists of (in order):

- a translation;
- a rotation about the centre point;
- a non-uniform scale about the centre point.

These parameters support changes to the size, orientation, and position of textures on shapes. Note that these operations appear reversed when viewed on the surface of geometry. For example, a scale value of (2 2) will scale the texture coordinates and have the net effect of shrinking the texture size by a factor of 2 (texture coordinates are twice as large and thus cause the texture to repeat). A translation of (0.5 0.0) translates the texture coordinates +.5 units along the S-axis and has the net effect of translating the texture -0.5 along the S-axis on the geometry's surface. A rotation of pi/2 of the texture coordinates results in a -pi/2 rotation of the texture on the geometry.

The center field specifies a translation offset in texture coordinate space about which the rotation and scale fields are applied. The scale field specifies a scaling factor in S and T of the texture coordinates about the center point. scale values shall be in the range (-pi, pi). The rotation field specifies a rotation in radians of the texture coordinates about the center point after the scale has been applied. A positive rotation value makes the texture coordinates rotate counterclockwise about the centre, thereby rotating the appearance of the texture itself clockwise. The translation field specifies a translation of the texture coordinates.

In matrix transformation notation, where Tc is the untransformed texture coordinate, Tc' is the transformed texture coordinate, C (center), T (translation), R (rotation), and S (scale) are the intermediate transformation matrices,

    Tc' = -C × S × R × C × T × Tc

Note that this transformation order is the reverse of the Transform node transformation order since the texture coordinates, not the texture, are being transformed (i.e., the texture coordinate system).

## Constructor & Destructor Documentation

## SoVRMLTextureTransform()

SoVRMLTextureTransform::SoVRMLTextureTransform | ( | void |  | ) |

Constructor.

## ~SoVRMLTextureTransform()

SoVRMLTextureTransform::~SoVRMLTextureTransform | ( |  | ) |

protected virtual

Destructor.

## Member Function Documentation

## getClassTypeId()

SoType SoVRMLTextureTransform::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoVRMLTextureTransform::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

## getFieldDataPtr()

const SoFieldData ** SoVRMLTextureTransform::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoVRMLTextureTransform::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

## initClass()

void SoVRMLTextureTransform::initClass | ( | void |  | ) |

static

## doAction()

void SoVRMLTextureTransform::doAction | ( | SoAction * | action | ) |

virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

## callback()

void SoVRMLTextureTransform::callback | ( | SoCallbackAction * | action | ) |

virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

## GLRender()

void SoVRMLTextureTransform::GLRender | ( | SoGLRenderAction * | action | ) |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

## getMatrix()

void SoVRMLTextureTransform::getMatrix | ( | SoGetMatrixAction * | action | ) |

virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

## pick()

void SoVRMLTextureTransform::pick | ( | SoPickAction * | action | ) |

virtual

Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

## Member Data Documentation

## translation

SoSFVec2f SoVRMLTextureTransform::translation

Translation value. Default values is (0, 0, 0).

## rotation

SoSFFloat SoVRMLTextureTransform::rotation

Rotation, in radians, around the centre points. Default value is 0.

## scale

SoSFVec2f SoVRMLTextureTransform::scale

Scale vector about the centre point. Default value is (1, 1).

## center

SoSFVec2f SoVRMLTextureTransform::center

Texture centre. Default value is (0.0, 0.0).

The documentation for this class was generated from the following files:

- SoVRMLTextureTransform.h
- TextureTransform.cpp